<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/

include("includes.php");

if(isset($_GET['icon'])) {
	$icon = sanitize($_GET['icon']);
	
	switch($icon) {
		case ("add") :
			$png = 'page_add';
		break;
		case ("back") :
			$png = 'control_rewind_blue';
		break;
		case ("cancel") :
			$png = 'control_rewind_blue';
		break;
		case ("comment") :
			$png = 'comment';
		break;
		case ("delete") :
			$png = 'page_delete';
		break;
		case ("shred") :
			$png = 'bin';
		break;
		case ("edit") :
			$png = 'page_edit';
		break;
		case ("error") :
			$png = 'error';
		break;
		case ("help") :
			$png = 'help';
		break;
		case ("logo") :
			$png = 'logo';
		break;
		case ("next") :
			$png = 'control_fastforward_blue';
		break;
		case ("save") :
			$png = 'page_save';
		break;
		case ("search") :
			$png = 'magnifier';
		break;
	}
	
	$image = imagecreatefrompng("images/" . $png . ".png");
	
	imagealphablending($image, true);
	
	imagesavealpha($image, true);
	
	header('Content-type: image/png');
	imagepng($image);
	imagedestroy($image);
}

if(isset($_GET['color'])) {
	$color = sanitize($_GET['color']);
	
	$image = imagecreatetruecolor($_SESSION['suser_imagesize'], $_SESSION['suser_imagesize']);
	
	$color = imagecolorallocate($image, hexdec(substr($color,0,2)), hexdec(substr($color,2,2)), hexdec(substr($color,4,2)));
	
	imagefill($image, 0, 0, $color);
	
	header('Content-type: image/png');
	imagepng($image);
	imagedestroy($image);
}
?>
