<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/
	
session_name('ipreg');
session_start();

// check for user_id, if unnkown, redirect to login
if (empty($_SESSION['suser_id'])) {
    $_SESSION['prelogin'] = $_SERVER['REQUEST_URI'];
    header("Location: login.php");
    exit;
}

// required config vars, may be overwritten later
$config_auth_ldap = false;
$config_ext = array();

include("config.php");

// connect to database
$dbh = new PDO("mysql:host=$config_mysql_host;dbname=$config_mysql_dbname;charset=utf8", $config_mysql_username, $config_mysql_password);
$dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
$dbh->setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
		
include("lib.php");

$language = lang_getfrombrowser($config_lang, $config_lang_default, null, false);

?>