<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/
	
include("includes.php");

$node_id = sanitize($_GET['node_id']);

include("header.php");

// node_ext
$sth = $dbh->prepare("SELECT node_id AS id_ext, node_ip AS ip_ext FROM node WHERE node_id=?");
$sth->execute([$node_id]);
$smarty->assign("node", $sth->fetch(PDO::FETCH_OBJ));

// options
$sql = "SELECT x.nat_id, n.node_ip, a.asset_name
	FROM nat AS x
	    LEFT JOIN node AS n ON (x.nat_int=n.node_id)
	    LEFT JOIN asset AS a USING (asset_id) 
	WHERE x.nat_ext=?
	ORDER BY INET_ATON(n.node_ip)";
$sth = $dbh->prepare($sql);
$sth->execute([$node_id]);
$nats = $sth->fetchAll();

$options = array();
foreach ($nats as $rec) {
    $options[$rec['nat_id']] = $rec['node_ip'] . '/' . $rec['asset_name'];
}
$smarty->assign("nat_options", $options);
$smarty->display("natdel.tpl");

include("footer.php");
?>
