<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/
	
include("includes.php");
		
$subnet_id = sanitize($_GET['subnet_id']);
		
include("header.php");
	
// subnet
$sql = "SELECT subnet_id AS id, subnet_address AS address, subnet_mask AS mask
        FROM subnet
        WHERE subnet_id=?";
$sth = $dbh->prepare($sql);
$sth->execute([$subnet_id]);
$smarty->assign("subnet", $sth->fetch(PDO::FETCH_OBJ));

// node		
$sql = "SELECT node_id AS id, node_ip AS ip
        FROM node
        WHERE subnet_id=?
        ORDER BY INET_ATON(node_ip)";
$sth = $dbh->prepare($sql);
$sth->execute([$subnet_id]);
$smarty->assign("nodes", $sth->fetchAll());

$smarty->display("subnetdel.tpl");
		
include("footer.php");
?>
