<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/
	
include("includes.php");
		
$subnet_id = sanitize($_GET['subnet_id']);
		
include("header.php");
		
$sql = "SELECT subnet_id AS id, subnet_address AS address, subnet_mask AS mask
        FROM subnet
        WHERE subnet_id=?";
$sth = $dbh->prepare($sql);
$sth->execute([$subnet_id]);

$smarty->assign("subnet", $sth->fetch(PDO::FETCH_OBJ));

// vlan
$sql = "SELECT vlan_id, vlan_number, vlan_name
        FROM vlan
        WHERE vlan_id NOT IN (
	    SELECT vlan_id FROM subnetvlan WHERE subnet_id=?
	)
        ORDER BY vlan_number";
$sth = $dbh->prepare($sql);
$sth->execute([$subnet_id]);
		
$vlans = $sth->fetchAll();
foreach ($vlans as $vlan) {
    $vlan_options[$vlan['vlan_id']] =  $vlan['vlan_name'] . ' (' . $vlan['vlan_number']. ')';
}
$smarty->assign("vlan_options", $vlan_options);

$smarty->display("subnetvlanadd.tpl");

include("footer.php");
?>
