<?php
/*****************************************************************************
IP Reg, a PHP/MySQL IPAM tool
Copyright (C) 2007-2009 Wietse Warendorff (up to v0.5)
Copyright (C) 2011-2023 Thomas Hooge

SPDX-License-Identifier: GPL-3.0-or-later
*****************************************************************************/
	
include("includes.php");
		
$vlan_id = sanitize($_GET['vlan_id']);
		
include("header.php");

$sql = "SELECT vlan_id AS id, vlan_name AS name, vlan_number AS number
        FROM vlan
        WHERE vlan_id=?";
$sth = $dbh->prepare($sql);
$sth->execute([$vlan_id]);
$smarty->assign("vlan", $sth->fetch(PDO::FETCH_OBJ));

	
// possible subnets to add to vlan
//   - exclude already assingned subnets from selection
$sql = "SELECT subnet_id, subnet_address, subnet_mask
        FROM subnet
        WHERE subnet_id NOT IN (SELECT subnet_id FROM subnetvlan WHERE vlan_id=?)
        ORDER BY INET_ATON(subnet_address)";
$sth = $dbh->prepare($sql);
$sth->execute([$vlan_id]);

$subnets = $sth->fetchAll();

foreach ($subnets as $subnet) {
    $subnet_options[$subnet['subnet_id']] = $subnet['subnet_address'].'/'.$subnet['subnet_mask'];
}
$smarty->assign("subnet_options", $subnet_options);
	
$smarty->display("vlansubnetadd.tpl");
		
include("footer.php");
?>
